using System;
using Unit4.CollectionsLib;
using System.Text;
/**
 *   :  
 * @author  , '  
 * @version 17/4/2007
 */
namespace ConsoleApplicationBuildCityMap
{
    class CityMap
    {
        private double[,] distanceBetweenCities;
        public CityMap (int nCities)
	    {
            this.distanceBetweenCities = new double[nCities, nCities];
		    for (int i=0; i<nCities; i++)
			    for (int j=0; j<nCities; j++)
				    this.distanceBetweenCities[i,j] = 0;
	    }
    	
	    public void SetDistance (int c1, int c2, double d)
	    {
		    this.distanceBetweenCities[c1,c2] = d;
		    this.distanceBetweenCities[c2,c1] = d;
	    }

        public double GetDistance(int c1, int c2)
	    {
		    return this.distanceBetweenCities[c1,c2];
	    }
    	
	    //not implemented
        public List<int> GetShortestPath(int c1, int c2)
	    {
		    return new List<int>();
	    }
        public double GetSmallDistance(int c1, int c2)
        {
            List<int> smallPath = GetShortestPath(c1, c2);
            Node<int> currentCity = smallPath.GetFirst();
            int previousCity = currentCity.GetInfo();
            currentCity = currentCity.GetNext();
            int nextCity = currentCity.GetInfo();
            double distance = GetDistance(previousCity, nextCity);
            while (currentCity.GetNext() != null)
            {
                previousCity = nextCity;
                currentCity = currentCity.GetNext();
                nextCity = currentCity.GetInfo();
                distance += GetDistance(previousCity, nextCity);
            }
            return distance;
        }

        
    }
}
